// @generated by protobuf-ts 2.9.1
// @generated from protobuf file "encryption.proto" (package "listener", syntax proto3)
// tslint:disable
import { ServiceType } from "@protobuf-ts/runtime-rpc";
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import { WireType } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import { UnknownFieldHandler } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { reflectionMergePartial } from "@protobuf-ts/runtime";
import { MESSAGE_TYPE } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
/**
 * @generated from protobuf message listener.DefaultStorageItem
 */
export interface DefaultStorageItem {
    /**
     * @generated from protobuf field: bytes ClientPublicKey = 1 [json_name = "ClientPublicKey"];
     */
    clientPublicKey: Uint8Array;
    /**
     * @generated from protobuf field: bytes ServerPublicKey = 2 [json_name = "ServerPublicKey"];
     */
    serverPublicKey: Uint8Array;
    /**
     * @generated from protobuf field: bytes ServerPrivateKey = 3 [json_name = "ServerPrivateKey"];
     */
    serverPrivateKey: Uint8Array;
}
/**
 * @generated from protobuf message listener.ExchangeRequest
 */
export interface ExchangeRequest {
    /**
     * @generated from protobuf field: bytes PublicKey = 1 [json_name = "PublicKey"];
     */
    publicKey: Uint8Array;
}
/**
 * @generated from protobuf message listener.ExchangeResponse
 */
export interface ExchangeResponse {
    /**
     * @generated from protobuf field: bytes PublicKey = 1 [json_name = "PublicKey"];
     */
    publicKey: Uint8Array;
}
// @generated message type with reflection information, may provide speed optimized methods
class DefaultStorageItem$Type extends MessageType<DefaultStorageItem> {
    constructor() {
        super("listener.DefaultStorageItem", [
            { no: 1, name: "ClientPublicKey", kind: "scalar", jsonName: "ClientPublicKey", T: 12 /*ScalarType.BYTES*/ },
            { no: 2, name: "ServerPublicKey", kind: "scalar", jsonName: "ServerPublicKey", T: 12 /*ScalarType.BYTES*/ },
            { no: 3, name: "ServerPrivateKey", kind: "scalar", jsonName: "ServerPrivateKey", T: 12 /*ScalarType.BYTES*/ }
        ]);
    }
    create(value?: PartialMessage<DefaultStorageItem>): DefaultStorageItem {
        const message = { clientPublicKey: new Uint8Array(0), serverPublicKey: new Uint8Array(0), serverPrivateKey: new Uint8Array(0) };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<DefaultStorageItem>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: DefaultStorageItem): DefaultStorageItem {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* bytes ClientPublicKey = 1 [json_name = "ClientPublicKey"];*/ 1:
                    message.clientPublicKey = reader.bytes();
                    break;
                case /* bytes ServerPublicKey = 2 [json_name = "ServerPublicKey"];*/ 2:
                    message.serverPublicKey = reader.bytes();
                    break;
                case /* bytes ServerPrivateKey = 3 [json_name = "ServerPrivateKey"];*/ 3:
                    message.serverPrivateKey = reader.bytes();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: DefaultStorageItem, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* bytes ClientPublicKey = 1 [json_name = "ClientPublicKey"]; */
        if (message.clientPublicKey.length)
            writer.tag(1, WireType.LengthDelimited).bytes(message.clientPublicKey);
        /* bytes ServerPublicKey = 2 [json_name = "ServerPublicKey"]; */
        if (message.serverPublicKey.length)
            writer.tag(2, WireType.LengthDelimited).bytes(message.serverPublicKey);
        /* bytes ServerPrivateKey = 3 [json_name = "ServerPrivateKey"]; */
        if (message.serverPrivateKey.length)
            writer.tag(3, WireType.LengthDelimited).bytes(message.serverPrivateKey);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.DefaultStorageItem
 */
export const DefaultStorageItem = new DefaultStorageItem$Type();
// @generated message type with reflection information, may provide speed optimized methods
class ExchangeRequest$Type extends MessageType<ExchangeRequest> {
    constructor() {
        super("listener.ExchangeRequest", [
            { no: 1, name: "PublicKey", kind: "scalar", jsonName: "PublicKey", T: 12 /*ScalarType.BYTES*/ }
        ]);
    }
    create(value?: PartialMessage<ExchangeRequest>): ExchangeRequest {
        const message = { publicKey: new Uint8Array(0) };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<ExchangeRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ExchangeRequest): ExchangeRequest {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* bytes PublicKey = 1 [json_name = "PublicKey"];*/ 1:
                    message.publicKey = reader.bytes();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: ExchangeRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* bytes PublicKey = 1 [json_name = "PublicKey"]; */
        if (message.publicKey.length)
            writer.tag(1, WireType.LengthDelimited).bytes(message.publicKey);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.ExchangeRequest
 */
export const ExchangeRequest = new ExchangeRequest$Type();
// @generated message type with reflection information, may provide speed optimized methods
class ExchangeResponse$Type extends MessageType<ExchangeResponse> {
    constructor() {
        super("listener.ExchangeResponse", [
            { no: 1, name: "PublicKey", kind: "scalar", jsonName: "PublicKey", T: 12 /*ScalarType.BYTES*/ }
        ]);
    }
    create(value?: PartialMessage<ExchangeResponse>): ExchangeResponse {
        const message = { publicKey: new Uint8Array(0) };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<ExchangeResponse>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ExchangeResponse): ExchangeResponse {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* bytes PublicKey = 1 [json_name = "PublicKey"];*/ 1:
                    message.publicKey = reader.bytes();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: ExchangeResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* bytes PublicKey = 1 [json_name = "PublicKey"]; */
        if (message.publicKey.length)
            writer.tag(1, WireType.LengthDelimited).bytes(message.publicKey);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.ExchangeResponse
 */
export const ExchangeResponse = new ExchangeResponse$Type();
/**
 * @generated ServiceType for protobuf service listener.Encryption
 */
export const Encryption = new ServiceType("listener.Encryption", [
    { name: "Exchange", options: {}, I: ExchangeRequest, O: ExchangeResponse }
]);
